import { type Options } from 'ajv';
import { type FastifyInstance, type ValidationResult as FastifyValidationResult, type RouteOptions } from 'fastify';
import { type Configuration, type RequestSection, type ValidationFormatter, type Validations } from './interfaces.js';
export interface ValidationResult extends FastifyValidationResult {
    dataPath: any;
    instancePath: string;
}
export declare const defaultAjvOptions: Options;
export declare function niceJoin(array: string[], lastSeparator?: string, separator?: string): string;
export declare const validationMessagesFormatters: Record<string, ValidationFormatter>;
export declare function convertValidationErrors(section: RequestSection, data: Record<string, unknown>, validationErrors: ValidationResult[]): Validations;
export declare function addResponseValidation(this: FastifyInstance, route: RouteOptions): void;
export declare function compileResponseValidationSchema(this: FastifyInstance, configuration: Configuration): void;
